//
//  View.m
//  Put
//
//  Created by NYU User on 11/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "View.h"


@implementation View


- (id) initWithFrame: (CGRect) frame {
	if ((self = [super initWithFrame: frame]) != nil) {
		// Initialization code
		filename = @"spj224.png";
			
		NSBundle *bundle = [NSBundle mainBundle];
		//NSLog(@"bundle.bundlePath == \"%@\"", bundle.bundlePath);	
		
		NSString *pathname = [bundle pathForResource:
			[filename stringByDeletingPathExtension]
			ofType: [filename pathExtension]
		];
		NSLog(@"pathname == \"%@\"", pathname);
		
		NSURL *url = [NSURL URLWithString: @"http://i5.nyu.edu:3000/"];
		if (url == nil) {
			NSLog(@"url is nil");
			[self release];
			return nil;
		}
		NSLog(@"url == \"%@\"", url);
		
		url = NSMakeCollectable(
			CFURLCreateCopyAppendingPathComponent(
				NULL, (CFURLRef)url, (CFStringRef)filename, false
			)
		);
		if (url == nil) {
			NSLog(@"url is nil");
			[self release];
			return nil;
		}
		NSLog(@"url == \"%@\"", url);
		
		NSInputStream *stream =
			[NSInputStream inputStreamWithFileAtPath: pathname];
		if (stream == nil) {
			NSLog(@"stream is nil");
			[self release];
			return nil;
		}
		
		NSMutableURLRequest *request =
			[NSMutableURLRequest requestWithURL: url];
		
		if (request == nil) {
			NSLog(@"request is nil");
			[self release];
			return nil;
		}
		
		[request setHTTPMethod: @"PUT"];
		[request setHTTPBodyStream: stream];
		[request setValue: @"image/png" forHTTPHeaderField: @"Content-Type"];
		
		//Get the number of bytes in the image file.
		
		NSFileManager *manager = [NSFileManager defaultManager];
		NSDictionary *attributes =
			[manager attributesOfItemAtPath: pathname error: NULL];
		NSNumber *contentLength = 
			(NSNumber *)[attributes objectForKey: NSFileSize];
		assert([contentLength isKindOfClass: [NSNumber class]]);
		NSString *description = [contentLength description];
        
		[request setValue: description forHTTPHeaderField: @"Content-Length"];
		NSLog(@"contentLength == %@", description);
		NSLog(@"request == %@", request);
		
		NSURLConnection *connection =
			[NSURLConnection connectionWithRequest: request
			delegate: self];
		
		if (connection == nil) {
			NSLog(@"connection == nil");
			[self release];
			return nil;
		}
		NSLog(@"connection == %@", connection);
	}
	return self;
}


// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void) drawRect: (CGRect) rect {
	// Drawing code
	UIImage *image = [UIImage imageNamed: filename];
	if (image == nil) {
		NSLog(@"could not find the image");
		return;
	}
	
	//upper left corner of image
	CGPoint p = CGPointMake(
		(self.bounds.size.width - image.size.width) / 2,
		(self.bounds.size.height - image.size.height) / 2
	);
	
	[image drawAtPoint: p];
}


- (void) dealloc {
	[super dealloc];
}


@end
